-- MOVIE for PC-6001mk2
--

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity P6MOVIE is
	port (
		CLK50M			: in    std_logic;						-- clock 50MHz input #1
		LED				: out   std_logic_vector(7 downto 0);	-- LED
		BUTTON			: in    std_logic_vector(1 downto 0);	-- push button
		SW				: in    std_logic_vector(3 downto 0);	-- DIPSW
		DRAM_D			: inout std_logic_vector(15 downto 0);	-- SDRAM data bus
		DRAM_A			: out   std_logic_vector(12 downto 0);	-- SDRAM address bus
		DRAM_CLK		: out   std_logic;						-- SDRAM clock output
		DRAM_CKE		: out   std_logic;						-- SDRAM clock enable
		DRAM_LDQM		: out   std_logic;						-- SDRAM LowerByte Data Mask
		DRAM_UDQM		: out   std_logic;						-- SDRAM UpperByte Data Mask
		DRAM_WE_N		: out   std_logic;						-- SDRAM write Enable
		DRAM_CAS_N		: out   std_logic;						-- SDRAM CAS
		DRAM_RAS_N		: out   std_logic;						-- SDRAM RAS
		DRAM_CS_N		: out   std_logic;						-- SDRAM chip select
		DRAM_BA			: out   std_logic_vector(1 downto 0);	-- SDRAM Bank
		I2C_SCLK		: out   std_logic;						-- I2C clock output
		I2C_SDAT		: inout std_logic;						-- I2C data
		G_SENSOR_CS_N	: out   std_logic;						-- G-SENSOR CS output
		G_SENSOR_INT	: in    std_logic;						-- G-SENSOR data input
		ADC_CS_N		: out   std_logic;						-- A/D CS output
		ADC_SADDR		: out   std_logic;						-- A/D address output
		ADC_SCLK		: out   std_logic;						-- A/D clock output
		ADC_SDAT		: in    std_logic;						-- A/D data input
		GPIO0_D_00		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_01		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_02		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_03		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_04		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_05		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_06		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_07		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_08		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_09		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_10		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_11		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_12		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_13		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_14		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_15		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_16		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_17		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_18		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_19		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_20		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_21		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_22		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_23		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_24		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_25		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_26		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_27		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_28		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_29		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_30		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_31		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_32		: inout std_logic;						-- GPIO #0 data
		GPIO0_D_33		: inout std_logic;						-- GPIO #0 data
		GPIO0_CLKIN_0	: in    std_logic;						-- GPIO #0 clock input
		GPIO0_CLKIN_1	: in    std_logic;						-- GPIO #0 clock input
		GPIO1_D_00		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_01		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_02		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_03		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_04		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_05		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_06		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_07		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_08		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_09		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_10		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_11		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_12		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_13		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_14		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_15		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_16		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_17		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_18		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_19		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_20		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_21		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_22		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_23		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_24		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_25		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_26		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_27		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_28		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_29		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_30		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_31		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_32		: inout std_logic;						-- GPIO #1 data
		GPIO1_D_33		: inout std_logic;						-- GPIO #1 data
		GPIO1_CLKIN_0	: in    std_logic;						-- GPIO #1 clock input
		GPIO1_CLKIN_1	: in    std_logic;						-- GPIO #1 clock input
		GPIO2_D_00		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_01		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_02		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_03		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_04		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_05		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_06		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_07		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_08		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_09		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_10		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_11		: inout std_logic;						-- GPIO #2 data
		GPIO2_D_12		: inout std_logic;						-- GPIO #2 data
		GPIO2_CLKIN_0	: in    std_logic;						-- GPIO #2 clock input
		GPIO2_CLKIN_1	: in    std_logic;						-- GPIO #2 clock input
		GPIO2_CLKIN_2	: in    std_logic						-- GPIO #2 clock input
	);
end P6MOVIE;

architecture RTL of P6MOVIE is

-- for PC-6001
	signal P6_A			: std_logic_vector(15 downto 0);
	signal P6_D_i		: std_logic_vector(7 downto 0);
	signal P6_D_o		: std_logic_vector(7 downto 0);
	signal P6_DOUTcnt	: std_logic;
	signal P6_nM1		: std_logic;
	signal P6_nIORQ		: std_logic;
	signal P6_nMREQ		: std_logic;
	signal P6_nWR		: std_logic;
	signal P6_nRD		: std_logic;
	signal P6_nRST		: std_logic;
	signal P6_nRAS2		: std_logic;
	signal P6_nEXCAS	: std_logic;
	signal P6_nDRD2		: std_logic;
	signal P6_4MCLK		: std_logic;
	signal P6_nMPX		: std_logic;
	signal P6_nOCS5		: std_logic;
	signal P6_nWE		: std_logic;
	signal P6_nCS3		: std_logic;
	signal P6_nCS2		: std_logic;
	signal P6_nEXINT	: std_logic;
	signal P6_nEROM		: std_logic;

	signal P6_MONcnt	: std_logic;

	signal d_o			: std_logic_vector(7 downto 0);
	signal d_o_f1		: std_logic_vector(7 downto 0);
	signal d_o_f2		: std_logic_vector(7 downto 0);

	signal doutcnt		: std_logic;
	signal doutcnt_f1	: std_logic;

	signal ncs2_f1		: std_logic;
	signal ncs3_f1		: std_logic;

	signal nras2_f1		: std_logic;
	signal nexcas_f1	: std_logic;
	signal ndrd2_f1		: std_logic;
	signal nwe_f1		: std_logic;

	signal add_f1		: std_logic_vector(15 downto 0);
	signal d_i_f1		: std_logic_vector(7 downto 0);

	signal nm1_f1		: std_logic;
	signal niorq_f1		: std_logic;
	signal nmreq_f1		: std_logic;
	signal nwr_f1		: std_logic;
	signal nrd_f1		: std_logic;

-- for SD
	signal SD_DO		: std_logic;
	signal SD_CLK		: std_logic;
	signal SD_DI		: std_logic;
	signal SD_CS		: std_logic;
	signal SD_EJECT		: std_logic;
	signal SD_OUTENB	: std_logic;

	signal eject_f1		: std_logic;

-- clock generate
	signal rstn			: std_logic;
	signal clk12m		: std_logic;
	signal clk50m_o		: std_logic;
	signal clk1s		: std_logic;
	signal rstn_int		: std_logic;
	signal rstn_ctrl	: std_logic;

-- control CPU
	signal ctrl_m1n		: std_logic;
	signal ctrl_mreqn	: std_logic;
	signal ctrl_iorqn	: std_logic;
	signal ctrl_rdn		: std_logic;
	signal ctrl_wrn		: std_logic;
	signal ctrl_rfshn	: std_logic;
	signal ctrl_a		: std_logic_vector(15 downto 0);
	signal ctrl_di		: std_logic_vector(7 downto 0);
	signal ctrl_do		: std_logic_vector(7 downto 0);

-- control CPU decode signals
	signal ctrl_memrdn		: std_logic;
	signal ctrl_memwrn		: std_logic;

	signal ctrlrom_csn		: std_logic;
	signal ctrlrom_csn_f1	: std_logic;
	signal ctrlrom_rdn		: std_logic;
	signal ctrlrom_wrn		: std_logic;
	signal ctrlrom_q		: std_logic_vector(7 downto 0);

-- SD read I/F
	signal sd_csn			: std_logic;
	signal sd_csn_f1		: std_logic;
	signal sd_datao			: std_logic_vector(7 downto 0);
	signal sdread_err		: std_logic;
	signal sdread_outenb	: std_logic;
	signal sdread_di		: std_logic;
	signal sdread_cs		: std_logic;
	signal sdread_clk		: std_logic;
	signal sdread_dbgtrg	: std_logic_vector(7 downto 0);
	signal sdread_monout	: std_logic_vector(8 downto 0);
	signal sd_bufadd		: std_logic_vector(12 downto 0);
	signal sd_bufdatao		: std_logic_vector(7 downto 0);
	signal cg0enb			: std_logic;
	signal cg0wr			: std_logic;
	signal cg1enb			: std_logic;
	signal cg1wr			: std_logic;
	signal pcm0enb			: std_logic;
	signal pcm0wr			: std_logic;
	signal pcm1enb			: std_logic;
	signal pcm1wr			: std_logic;
	signal cgframe			: std_logic_vector(3 downto 0);
	signal pcmframe			: std_logic_vector(2 downto 0);
	signal cgfileend		: std_logic;
	signal pcmfileend		: std_logic;
	signal cgsel			: std_logic;
	signal sdif_do			: std_logic_vector(7 downto 0);
	signal sdif_csn			: std_logic;
	signal ctrlrst			: std_logic;

-- cg control
	signal cg_do		: std_logic_vector(7 downto 0);
	signal cg0empty		: std_logic;
	signal cg1empty		: std_logic;
	signal pcm0empty	: std_logic;
	signal pcm1empty	: std_logic;
	signal cg_monout	: std_logic_vector(19 downto 0);

-- for Probe
	signal probedat		: std_logic_vector(31 downto 0);

	signal nm1_f2		: std_logic;
	signal niorq_f2		: std_logic;
	signal nmreq_f2		: std_logic;
	signal nwr_f2		: std_logic;
	signal nrd_f2		: std_logic;
	signal nras2_f2		: std_logic;
	signal nexcas_f2	: std_logic;
	signal ndrd2_f2		: std_logic;

	signal cgsel_f1		: std_logic;

	signal add_f2		: std_logic_vector(15 downto 0);
	signal d_i_f2		: std_logic_vector(7 downto 0);
	signal do_f1		: std_logic_vector(7 downto 0);

	signal cntprg_do	: std_logic_vector(7 downto 0);
	signal rom_do		: std_logic_vector(7 downto 0);

	component CLKGEN is
		port (
			CLK50M		: in  std_logic;
			RSTN		: in  std_logic;
			CLK12MOUT	: out std_logic;
			CLK50MOUT	: out std_logic;
			CLK1SOUT	: out std_logic;
			LOCK_PLL	: out std_logic;
			CPU_RSTN	: out std_logic
		);
	end component;

	component T80s
		generic(
			Mode : integer := 0;	-- 0 => Z80, 1 => Fast Z80, 2 => 8080, 3 => GB
			T2Write : integer := 0;	-- 0 => WR_n active in T3, /=0 => WR_n active in T2
			IOWait : integer := 1	-- 0 => Single cycle I/O, 1 => Std I/O cycle
		);
		port(
			RESET_n		: in std_logic;
			CLK_n		: in std_logic;
			WAIT_n		: in std_logic;
			INT_n		: in std_logic;
			NMI_n		: in std_logic;
			BUSRQ_n		: in std_logic;
			M1_n		: out std_logic;
			MREQ_n		: out std_logic;
			IORQ_n		: out std_logic;
			RD_n		: out std_logic;
			WR_n		: out std_logic;
			RFSH_n		: out std_logic;
			HALT_n		: out std_logic;
			BUSAK_n		: out std_logic;
			A			: out std_logic_vector(15 downto 0);
			DI			: in std_logic_vector(7 downto 0);
			DO			: out std_logic_vector(7 downto 0)
		);
	end component;

	component CTRLROM_WRAP is
		port (
			ADDRESS	: in  std_logic_vector(11 downto 0);
			DATA	: in  std_logic_vector(7 downto 0);
			RDN		: in  std_logic;
			WRN		: in  std_logic;
			CLK		: in  std_logic;
			RSTN	: in  std_logic;
			Q		: out std_logic_vector(7 downto 0)
		);
	end component;

	component EXROM is
		port (
			address		: in  std_logic_vector(13 downto 0);
			clock		: in  std_logic;
			q			: out std_logic_vector(7 downto 0)
		);
	end component;

	component CNTPRG is
		port (
			address		: in  std_logic_vector(11 downto 0);
			clock		: in  std_logic;
			q			: out std_logic_vector(7 downto 0)
		);
	end component;

	component CGCNT is
		port (
			CGSEL		: in  std_logic;
			M1_N		: in  std_logic;
			IORQ_N		: in  std_logic;
			MREQ_N		: in  std_logic;
			WR_N		: in  std_logic;
			RD_N		: in  std_logic;
			RAS2_N		: in  std_logic;
			EXCAS_N		: in  std_logic;
			DRD2_N		: in  std_logic;
			BUFADD		: in  std_logic_vector(12 downto 0);
			BUFDATA		: in  std_logic_vector(7 downto 0);
			CG0ENB		: in  std_logic;
			CG0WR		: in  std_logic;
			CG1ENB		: in  std_logic;
			CG1WR		: in  std_logic;
			PCM0ENB		: in  std_logic;
			PCM0WR		: in  std_logic;
			PCM1ENB		: in  std_logic;
			PCM1WR		: in  std_logic;
			CGFRAME		: in  std_logic_vector(3 downto 0);
			PCMFRAME	: in  std_logic_vector(2 downto 0);
			CGFILEEND	: in  std_logic;
			PCMFILEEND	: in  std_logic;
			CTRLRST		: in  std_logic;
			SW			: in  std_logic_vector(1 downto 0);
			RSTN		: in  std_logic;
			CLK			: in  std_logic;
			Q			: out std_logic_vector(7 downto 0);
			CG0EMPTY	: out std_logic;
			CG1EMPTY	: out std_logic;
			PCM0EMPTY	: out std_logic;
			PCM1EMPTY	: out std_logic;
			MONOUT		: out std_logic_vector(19 downto 0)
		);
	end component;

	component SDREADIF is
		port (
			SD_DO		: in  std_logic;						-- from SD card
			SD_EJECT	: in  std_logic;						-- from SD card
			ADD			: in  std_logic_vector(15 downto 0);	-- from CPU
			DATAI		: in  std_logic_vector(7 downto 0);		-- from CPU
			WRN			: in  std_logic;						-- from CPU
			RDN			: in  std_logic;						-- from CPU
			P6_ADD		: in  std_logic_vector(15 downto 0);	-- from P6
			P6_DATAI	: in  std_logic_vector(7 downto 0);		-- from P6
			P6_M1N		: in  std_logic;						-- from P6
			P6_IORQN	: in  std_logic;						-- from P6
			P6_MREQN	: in  std_logic;						-- from P6
			P6_WRN		: in  std_logic;						-- from P6
			P6_RDN		: in  std_logic;						-- from P6
			CG0EMPTY	: in  std_logic;
			CG1EMPTY	: in  std_logic;
			PCM0EMPTY	: in  std_logic;
			PCM1EMPTY	: in  std_logic;
			CLK50M		: in  std_logic;
			RSTN		: in  std_logic;
			DATAO		: out std_logic_vector(7 downto 0);		-- to CPU
			BUFADD		: out std_logic_vector(12 downto 0);
			BUFDATAO	: out std_logic_vector(7 downto 0);
			CG0ENB		: out std_logic;
			CG0WR		: out std_logic;
			CG1ENB		: out std_logic;
			CG1WR		: out std_logic;
			PCM0ENB		: out std_logic;
			PCM0WR		: out std_logic;
			PCM1ENB		: out std_logic;
			PCM1WR		: out std_logic;
			SD_ERR		: out std_logic;
			SD_OUTENB	: out std_logic;
			SD_DI		: out std_logic;						-- to SD card
			SD_CS		: out std_logic;						-- to SD card
			SD_CLK		: out std_logic;						-- to SD card
			CGFRAME		: out std_logic_vector(3 downto 0);
			PCMFRAME	: out std_logic_vector(2 downto 0);
			CGFILEEND	: out std_logic;
			PCMFILEEND	: out std_logic;
			CGSEL		: out std_logic;
			P6_DO		: out std_logic_vector(7 downto 0);		-- to P6
			P6_CSN		: out std_logic;						-- to P6
			CTRLRST		: out std_logic;
			DBGTRG		: out std_logic_vector(7 downto 0);
			MONOUT		: out std_logic_vector(8 downto 0)
		);
	end component;


begin

-- RESET and CLOCK generate

	rstn <=	'0' when (BUTTON(0) = '0' or P6_nRST = '0') else
			'1';

	P6_MONcnt <= '0';

	U_CLKGEN : CLKGEN
	port map (
		CLK50M		=> CLK50M,
		RSTN		=> rstn,
		CLK12MOUT	=> clk12m,
		CLK50MOUT	=> clk50m_o,
		CLK1SOUT	=> clk1s,
		LOCK_PLL	=> rstn_int,
		CPU_RSTN	=> rstn_ctrl
	);


-- data latch from PC-6001
	process (clk50m_o,rstn_int)
	begin
		if (rstn_int = '0') then
			ncs2_f1   <= '1';
			ncs3_f1   <= '1';
			nras2_f1  <= '1';
			nexcas_f1 <= '1';
			ndrd2_f1  <= '1';
			nwe_f1    <= '1';
		elsif (clk50m_o'event and clk50m_o = '1') then
			ncs2_f1   <= P6_nCS2;
			ncs3_f1   <= P6_nCS3;
			nras2_f1  <= P6_nRAS2;
			nexcas_f1 <= P6_nEXCAS;
			ndrd2_f1  <= P6_nDRD2;
			nwe_f1    <= P6_nWE;
		end if;
	end process;

	process (clk50m_o,rstn_int)
	begin
		if (rstn_int = '0') then
			add_f1 <= (others => '0');
			d_i_f1 <= (others => '0');
		elsif (clk50m_o'event and clk50m_o = '1') then
			add_f1 <= P6_A;
			d_i_f1 <= P6_D_i;
		end if;
	end process;

	process (clk50m_o,rstn_int)
	begin
		if (rstn_int = '0') then
			nm1_f1   <= '1';
			niorq_f1 <= '1';
			nmreq_f1 <= '1';
			nwr_f1   <= '1';
			nrd_f1   <= '1';
		elsif (clk50m_o'event and clk50m_o = '1') then
			nm1_f1   <= P6_nM1;
			niorq_f1 <= P6_nIORQ;
			nmreq_f1 <= P6_nMREQ;
			nwr_f1   <= P6_nWR;
			nrd_f1   <= P6_nRD;
		end if;
	end process;


	U_EXROM : EXROM
	port map (
		address		=> add_f1(13 downto 0),
		clock		=> clk50m_o,
		q			=> rom_do
	);

	U_CNTPRG : CNTPRG
	port map (
		address		=> add_f1(11 downto 0),
		clock		=> clk50m_o,
		q			=> cntprg_do
	);

	U_CGCNT : CGCNT
	port map (
		CGSEL		=> cgsel,
		M1_N		=> nm1_f1,
		IORQ_N		=> niorq_f1,
		MREQ_N		=> nmreq_f1,
		WR_N		=> nwr_f1,
		RD_N		=> nrd_f1,
		RAS2_N		=> nras2_f1,
		EXCAS_N		=> nexcas_f1,
		DRD2_N		=> ndrd2_f1,
		BUFADD		=> sd_bufadd,
		BUFDATA		=> sd_bufdatao,
		CG0ENB		=> cg0enb,
		CG0WR		=> cg0wr,
		CG1ENB		=> cg1enb,
		CG1WR		=> cg1wr,
		PCM0ENB		=> pcm0enb,
		PCM0WR		=> pcm0wr,
		PCM1ENB		=> pcm1enb,
		PCM1WR		=> pcm1wr,
		CGFRAME		=> cgframe,
		PCMFRAME	=> pcmframe,
		CGFILEEND	=> cgfileend,				
		PCMFILEEND	=> pcmfileend,
		CTRLRST		=> ctrlrst,
		SW			=> SW(1 downto 0),
		RSTN		=> rstn_int,
		CLK			=> clk50m_o,
		Q			=> cg_do,
		CG0EMPTY	=> cg0empty,
		CG1EMPTY	=> cg1empty,
		PCM0EMPTY	=> pcm0empty,
		PCM1EMPTY	=> pcm1empty,
		MONOUT		=> cg_monout
	);

	P6_D_o <=
		sdif_do   when (sdif_csn = '0') else
		cg_do     when (cgsel = '1' and nras2_f1 = '0' and nexcas_f1 = '0' and ndrd2_f1 = '0') else
		cntprg_do when (nras2_f1 = '0' and nexcas_f1 = '0' and ndrd2_f1 = '0') else
		rom_do    when (ncs2_f1 = '0' or ncs3_f1 = '0') else
		(others => '1');

	P6_DOUTcnt <=
		'1' when (sdif_csn = '0') else
		'1' when (nras2_f1 = '0' and nexcas_f1 = '0' and ndrd2_f1 = '0') else
		'1' when (ncs2_f1 = '0' or ncs3_f1 = '0') else
		'0';

--	process (clk50m_o,rstn_int)
--	begin
--		if (rstn_int = '0') then
--			d_o    <= (others => '1');
--			d_o_f1 <= (others => '1');
--			d_o_f2 <= (others => '1');
--		elsif (clk50m_o'event and clk50m_o = '1') then
--			if (sdif_csn = '0') then
--				d_o <= sdif_do;
--			elsif (cgsel = '1' and nras2_f1 = '0' and nexcas_f1 = '0' and ndrd2_f1 = '0') then
--				d_o <= cg_do;
--			elsif (nras2_f1 = '0' and nexcas_f1 = '0' and ndrd2_f1 = '0') then
--				d_o <= cntprg_do;
--			elsif (ncs2_f1 = '0' or ncs3_f1 = '0') then
--				d_o <= rom_do;
--			else
--				d_o <= (others => '1');
--			end if;
--
--			d_o_f1 <= d_o;
--			d_o_f2 <= d_o_f1;
--		end if;
--	end process;
--
--	P6_D_o <= d_o_f2;
--
--	process (clk50m_o,rstn_int)
--	begin
--		if (rstn_int = '0') then
--			doutcnt    <= '0';
--			doutcnt_f1 <= '0';
--		elsif (clk50m_o'event and clk50m_o = '1') then
--			if (sdif_csn = '0') then
--				doutcnt    <= '1';
--				doutcnt_f1 <= '1';
--			elsif (nras2_f1 = '0' and nexcas_f1 = '0' and ndrd2_f1 = '0') then
--				doutcnt    <= '1';
--				doutcnt_f1 <= '1';
--			elsif (ncs2_f1 = '0' or ncs3_f1 = '0') then
--				doutcnt    <= '1';
--				doutcnt_f1 <= '1';
--			else
--				doutcnt    <= '0';
--				doutcnt_f1 <= doutcnt;
--			end if;
--		end if;
--	end process;
--
--	P6_DOUTcnt <= doutcnt;

-- control CPU
	U_T80CTRL : T80s
	generic map (
		Mode 	=> 0,	-- 0 => Z80, 1 => Fast Z80, 2 => 8080, 3 => GB
		T2Write => 0,	-- 0 => WR_n active in T3, /=0 => WR_n active in T2
		IOWait  => 1	-- 0 => Single cycle I/O, 1 => Std I/O cycle
	)
	port map (
		RESET_n		=> rstn_ctrl,
		CLK_n		=> clk12m,
		WAIT_n		=> '1',
		INT_n		=> '1',
		NMI_n		=> '1',
		BUSRQ_n		=> '1',
		M1_n		=> ctrl_m1n,
		MREQ_n		=> ctrl_mreqn,
		IORQ_n		=> ctrl_iorqn,
		RD_n		=> ctrl_rdn,
		WR_n		=> ctrl_wrn,
		RFSH_n		=> ctrl_rfshn,
		HALT_n		=> open,
		BUSAK_n		=> open,
		A			=> ctrl_a,
		DI			=> ctrl_di,
		DO			=> ctrl_do
	);

	ctrl_memrdn <= '0' when (ctrl_mreqn = '0' and ctrl_rdn = '0') else '1';
	ctrl_memwrn <= '0' when (ctrl_mreqn = '0' and ctrl_wrn = '0') else '1';

	ctrl_di <=	sd_datao      when (sd_csn      = '0' or sd_csn_f1      = '0') else
				ctrlrom_q     when (ctrlrom_csn = '0' or ctrlrom_csn_f1 = '0') else
				(others => '1');

	process (clk50m_o,rstn_int)
	begin
		if (rstn_int = '0') then
			sd_csn_f1      <= '1';
			ctrlrom_csn_f1 <= '1';
		elsif (clk50m_o'event and clk50m_o = '1') then
			sd_csn_f1      <= sd_csn;
			ctrlrom_csn_f1 <= ctrlrom_csn;
		end if;
	end process;


-- control ROM
	U_CTRLROM_WRAP : CTRLROM_WRAP
	port map (
		ADDRESS	=> ctrl_a(11 downto 0),
		DATA	=> ctrl_do,
		RDN		=> ctrlrom_rdn,
		WRN		=> ctrlrom_wrn,
		CLK		=> clk50m_o,
		RSTN	=> rstn_int,
		Q		=> ctrlrom_q
	);

	ctrlrom_csn <= '0' when (ctrl_a(15 downto 12) = "0000") else '1';
	ctrlrom_rdn <= ctrlrom_csn or ctrl_memrdn;
	ctrlrom_wrn <= ctrlrom_csn or ctrl_memwrn;



	U_SDREADIF : SDREADIF
	port map (
		SD_DO		=> SD_DO,
		SD_EJECT	=> eject_f1,
		ADD			=> ctrl_a,
		DATAI		=> ctrl_do,
		WRN			=> ctrl_memwrn,
		RDN			=> ctrl_memrdn,
		P6_ADD		=> add_f1,
		P6_DATAI	=> d_i_f1,
		P6_M1N		=> nm1_f1,
		P6_IORQN	=> niorq_f1,
		P6_MREQN	=> nmreq_f1,
		P6_WRN		=> nwr_f1,
		P6_RDN		=> nrd_f1,
		CG0EMPTY	=> cg0empty,
		CG1EMPTY	=> cg1empty,
		PCM0EMPTY	=> pcm0empty,
		PCM1EMPTY	=> pcm1empty,
		CLK50M		=> clk50m_o,
		RSTN		=> rstn_int,
		DATAO		=> sd_datao,
		BUFADD		=> sd_bufadd,
		BUFDATAO	=> sd_bufdatao,
		CG0ENB		=> cg0enb,
		CG0WR		=> cg0wr,
		CG1ENB		=> cg1enb,
		CG1WR		=> cg1wr,
		PCM0ENB		=> pcm0enb,
		PCM0WR		=> pcm0wr,
		PCM1ENB		=> pcm1enb,
		PCM1WR		=> pcm1wr,
		SD_ERR		=> sdread_err,
		SD_OUTENB	=> sdread_outenb,
		SD_DI		=> sdread_di,
		SD_CS		=> sdread_cs,
		SD_CLK		=> sdread_clk,
		CGFRAME		=> cgframe,
		PCMFRAME	=> pcmframe,
		CGFILEEND	=> cgfileend,
		PCMFILEEND	=> pcmfileend,
		CGSEL		=> cgsel,
		P6_DO		=> sdif_do,
		P6_CSN		=> sdif_csn,
		CTRLRST		=> ctrlrst,
		DBGTRG		=> sdread_dbgtrg,
		MONOUT		=> sdread_monout
	);


	sd_csn <= '0' when (ctrl_a(15 downto 12) = "1000") else '1';

	SD_OUTENB <= sdread_outenb;
	SD_DI     <= sdread_di when (sdread_outenb = '1') else 'Z';
	SD_CS     <= sdread_cs when (sdread_outenb = '1') else 'Z';
	SD_CLK    <= sdread_clk;

	process (clk50m_o,rstn_int)
	begin
		if (rstn_int = '0') then
			eject_f1 <= '1';
		elsif (clk50m_o'event and clk50m_o = '1') then
			eject_f1 <= SD_EJECT;
		end if;
	end process;

	LED(0) <= sdread_outenb;
	LED(1) <= sdread_err and clk1s;
	LED(2) <= eject_f1 and clk1s;

	LED(7 downto 3) <= (others => '0');


-- for monitor
	process (clk50m_o,rstn_int)
	begin
		if (rstn_int = '0') then
			nm1_f2   <= '1';
			niorq_f2 <= '1';
			nmreq_f2 <= '1';
			nwr_f2   <= '1';
			nrd_f2   <= '1';
			nras2_f2 <= '1';
			nexcas_f2<= '1';
			ndrd2_f2 <= '1';
			cgsel_f1 <= '1';
			add_f2   <= (others => '0');
			d_i_f2   <= (others => '0');
			do_f1    <= (others => '0');
		elsif (clk50m_o'event and clk50m_o = '1') then
			nm1_f2   <= nm1_f1;
			niorq_f2 <= niorq_f1;
			nmreq_f2 <= nmreq_f1;
			nwr_f2   <= nwr_f1;
			nrd_f2   <= nrd_f1;
			nras2_f2 <= nras2_f1;
			nexcas_f2<= nexcas_f1;
			ndrd2_f2 <= ndrd2_f1;
			cgsel_f1 <= cgsel;
			add_f2   <= add_f1;
			d_i_f2   <= d_i_f1;
			do_f1    <= P6_D_o;
		end if;
	end process;


--	probedat(0) <= P6_nRST;
--	probedat(1) <= sdread_err;
--	probedat(2) <= sdread_outenb;
--	probedat(0) <= clk50m_o;
--	probedat(1) <= rstn_int;
--	probedat(2) <= cgsel;
--	probedat(3) <= sdread_di;
--	probedat(4) <= sdread_cs;
--	probedat(5) <= sdread_clk;
--	probedat(6) <= SD_DO;
--	probedat(7) <= BUTTON(0);
--
--	probedat(15 downto 8) <= sdread_monout(7 downto 0);
--	probedat(16) <= cg0empty;
--	probedat(17) <= cg1empty;
--	probedat(18) <= pcm0empty;
--	probedat(19) <= pcm1empty;
--	probedat(20) <= cg0enb;
--	probedat(21) <= cg0wr;
--	probedat(22) <= pcm1enb;
--	probedat(23) <= pcm1wr;

--	probedat(0) <= sdread_dbgtrg(0);
--	probedat(1) <= sdread_err;
--	probedat(2) <= rstn_int;
--	probedat(3) <= ctrl_m1n;
--	probedat(4) <= ctrl_iorqn;
--	probedat(5) <= ctrl_mreqn;
--	probedat(6) <= ctrl_wrn;
--	probedat(7) <= ctrl_rdn;
--
--	probedat(15 downto 8) <= ctrl_di;
--	probedat(23 downto 16) <= ctrl_a(7 downto 0);

--	probedat(0) <= rstn_int;
--	probedat(1) <= sdread_dbgtrg(0);
--	probedat(2) <= P6_DOUTcnt;
--	probedat(3) <= nm1_f2;
--	probedat(4) <= niorq_f2;
--	probedat(5) <= nmreq_f2;
--	probedat(6) <= nwr_f2;
--	probedat(7) <= nrd_f2;

--	probedat(15 downto 8)  <= sdread_monout(7 downto 0);
--	probedat(23 downto 16) <= P6_D_o when (P6_DOUTcnt = '1') else d_i_f1;

--	probedat(7 downto 4)  <= cg_monout(19 downto 16);

--	probedat(0) <= sdread_monout(8);
--	probedat(1) <= sdread_dbgtrg(0);
--	probedat(2) <= sdread_outenb;
--	probedat(3) <= sdread_di;
--	probedat(4) <= sdread_cs;
--	probedat(5) <= sdread_clk;
--	probedat(6) <= SD_DO;
--	probedat(7) <= eject_f1;

--	probedat(0) <= nras2_f2;
----	probedat(1) <= nexcas_f2;
----	probedat(1) <= cg_monout(2);
--	probedat(1) <= clk50m_o;
--	probedat(2) <= ndrd2_f2;
--	probedat(3) <= nm1_f2;
--	probedat(4) <= niorq_f2;
----	probedat(5) <= nmreq_f2;
--	probedat(5) <= cg_monout(8);
----	probedat(6) <= nwr_f2;
--	probedat(6) <= P6_DOUTcnt;
--	probedat(7) <= nrd_f2;

--	probedat(0) <= P6_nRST;
--	probedat(1) <= BUTTON(0);
--	probedat(2) <= rstn;
--	probedat(3) <= rstn_int;
--	probedat(4) <= rstn_ctrl;
--	probedat(5) <= clk50m_o;
--	probedat(6) <= eject_f1;
--	probedat(7) <= clk1s;

--	probedat(23 downto 16) <= do_f1;

--	probedat(15 downto 8)  <= sdread_monout(7 downto 0);
--	probedat(23 downto 16) <= (others => '0');

--	probedat(23 downto 8)  <= cg_monout(15 downto 0);
--	probedat(19 downto 8)  <= cg_monout(11 downto 0);

--	probedat(20) <= cg0empty;
--	probedat(21) <= cg1empty;
--	probedat(22) <= pcm0empty;
--	probedat(23) <= pcm1empty;

--	probedat(15 downto 8)  <= cg_monout(15 downto 0);
--	probedat(23 downto 16) <= do_f1;

--	probedat(23 downto 8)  <= "000" & sd_bufadd;

--	probedat(15 downto 8) <= P6_D_o when (P6_DOUTcnt = '1') else d_i_f1;
--	probedat(15 downto 8) <= d_i_f1;
--	probedat(23 downto 16) <= add_f2(7 downto 0);



	probedat(23 downto  0) <= (others => '0');
	probedat(31 downto 24) <= (others => '0');

	P6_nEXINT	<= '1';
	P6_nEROM	<= '1';



-- pin assign for PC-6001 and SD
	P6_A(15)	<= GPIO0_D_08;
	P6_A(14)	<= GPIO0_D_09;
	P6_A(13)	<= GPIO0_D_10;
	P6_A(12)	<= GPIO0_D_11;
	P6_A(11)	<= GPIO0_D_12;
	P6_A(10)	<= GPIO0_D_13;
	P6_A(9)		<= GPIO0_D_24;
	P6_A(8)		<= GPIO0_D_15;
	P6_A(7)		<= GPIO0_D_26;
	P6_A(6)		<= GPIO0_D_17;
	P6_A(5)		<= GPIO0_D_18;
	P6_A(4)		<= GPIO0_D_19;
	P6_A(3)		<= GPIO0_D_20;
	P6_A(2)		<= GPIO0_D_21;
	P6_A(1)		<= GPIO0_D_22;
	P6_A(0)		<= GPIO0_D_23;
	P6_D_i(7)	<= GPIO0_D_00;
	P6_D_i(6)	<= GPIO0_D_01;
	P6_D_i(5)	<= GPIO0_D_02;
	P6_D_i(4)	<= GPIO0_D_03;
	P6_D_i(3)	<= GPIO0_D_04;
	P6_D_i(2)	<= GPIO0_D_05;
	P6_D_i(1)	<= GPIO0_D_06;
	P6_D_i(0)	<= GPIO0_D_07;
	GPIO0_D_00	<= P6_D_o(7) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_01	<= P6_D_o(6) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_02	<= P6_D_o(5) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_03	<= P6_D_o(4) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_04	<= P6_D_o(3) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_05	<= P6_D_o(2) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_06	<= P6_D_o(1) when (P6_DOUTcnt = '1') else 'Z';
	GPIO0_D_07	<= P6_D_o(0) when (P6_DOUTcnt = '1') else 'Z';

	P6_nM1		<= GPIO0_D_33;
	P6_nIORQ	<= GPIO0_D_31;
	P6_nMREQ	<= GPIO0_D_29;
	P6_nWR		<= GPIO0_D_27;
	P6_nRD		<= GPIO0_D_25;
	P6_nRST		<= GPIO0_CLKIN_0;
	P6_nRAS2	<= GPIO0_D_30;
	P6_nEXCAS	<= GPIO0_D_28;
	P6_nDRD2	<= GPIO0_CLKIN_1;
	P6_nMPX		<= GPIO1_D_00;		-- when P6_MONcnt = '0'
	P6_4MCLK	<= GPIO1_D_31;		-- when P6_MONcnt = '0'
	P6_nWE		<= GPIO1_D_01;		-- when P6_MONcnt = '0'
	P6_nOCS5	<= GPIO1_D_33;		-- when P6_MONcnt = '0'
	P6_nCS2		<= GPIO1_D_03;		-- when P6_MONcnt = '0'
	P6_nCS3		<= GPIO1_D_02;		-- when P6_MONcnt = '0'

	GPIO0_D_14	<= P6_DOUTcnt;
	GPIO0_D_16	<= P6_MONcnt;

-- for SD
	SD_DO		<= GPIO1_CLKIN_1;
	GPIO0_D_32	<= SD_CLK;
	GPIO1_D_30	<= SD_DI when (SD_OUTENB = '1') else 'Z';
	GPIO1_D_32	<= SD_CS when (SD_OUTENB = '1') else 'Z';
	SD_EJECT	<= GPIO1_CLKIN_0;

-- for Probe
	GPIO1_D_00	<= probedat(31) when (P6_MONcnt = '1') else 'Z';
	GPIO1_D_01	<= probedat(29) when (P6_MONcnt = '1') else 'Z';
	GPIO1_D_02	<= probedat(26) when (P6_MONcnt = '1') else 'Z';
	GPIO1_D_03	<= probedat(27) when (P6_MONcnt = '1') else 'Z';
	GPIO1_D_04	<= probedat(24) when (P6_MONcnt = '1') else P6_nEXINT;
	GPIO1_D_05	<= probedat(25) when (P6_MONcnt = '1') else P6_nEROM;
	GPIO1_D_06	<= probedat(22);
	GPIO1_D_07	<= probedat(23);
	GPIO1_D_08	<= probedat(20);
	GPIO1_D_09	<= probedat(21);
	GPIO1_D_10	<= probedat(18);
	GPIO1_D_11	<= probedat(19);
	GPIO1_D_12	<= probedat(16);
	GPIO1_D_13	<= probedat(17);
	GPIO1_D_14	<= probedat(14);
	GPIO1_D_15	<= probedat(15);
	GPIO1_D_16	<= probedat(12);
	GPIO1_D_17	<= probedat(13);
	GPIO1_D_18	<= probedat(10);
	GPIO1_D_19	<= probedat(11);
	GPIO1_D_20	<= probedat(8);
	GPIO1_D_21	<= probedat(9);
	GPIO1_D_22	<= probedat(6);
	GPIO1_D_23	<= probedat(7);
	GPIO1_D_24	<= probedat(4);
	GPIO1_D_25	<= probedat(5);
	GPIO1_D_26	<= probedat(2);
	GPIO1_D_27	<= probedat(3);
	GPIO1_D_28	<= probedat(0);
	GPIO1_D_29	<= probedat(1);
	GPIO1_D_31	<= probedat(30) when (P6_MONcnt = '1') else 'Z';
	GPIO1_D_33	<= probedat(28) when (P6_MONcnt = '1') else 'Z';

-- input only signal
	GPIO0_D_00	<= 'Z';
	GPIO0_D_01	<= 'Z';
	GPIO0_D_02	<= 'Z';
	GPIO0_D_03	<= 'Z';
	GPIO0_D_04	<= 'Z';
	GPIO0_D_05	<= 'Z';
	GPIO0_D_06	<= 'Z';
	GPIO0_D_07	<= 'Z';
	GPIO0_D_08	<= 'Z';
	GPIO0_D_09	<= 'Z';
	GPIO0_D_10	<= 'Z';
	GPIO0_D_11	<= 'Z';
	GPIO0_D_12	<= 'Z';
	GPIO0_D_13	<= 'Z';
	GPIO0_D_15	<= 'Z';
	GPIO0_D_17	<= 'Z';
	GPIO0_D_18	<= 'Z';
	GPIO0_D_19	<= 'Z';
	GPIO0_D_20	<= 'Z';
	GPIO0_D_21	<= 'Z';
	GPIO0_D_22	<= 'Z';
	GPIO0_D_23	<= 'Z';
	GPIO0_D_24	<= 'Z';
	GPIO0_D_25	<= 'Z';
	GPIO0_D_27	<= 'Z';
	GPIO0_D_29	<= 'Z';
	GPIO0_D_31	<= 'Z';
	GPIO0_D_33	<= 'Z';

-- unused pin
	DRAM_D			<= (others => 'Z');
	DRAM_A			<= (others => '0');
	DRAM_CLK		<= '0';
	DRAM_CKE		<= '0';
	DRAM_LDQM		<= '0';
	DRAM_UDQM		<= '0';
	DRAM_WE_N		<= '1';
	DRAM_CAS_N		<= '1';
	DRAM_RAS_N		<= '1';
	DRAM_CS_N		<= '1';
	DRAM_BA			<= (others => '0');
	I2C_SCLK		<= '0';
	I2C_SDAT		<= 'Z';
	G_SENSOR_CS_N	<= '0';
	ADC_CS_N		<= '1';
	ADC_SADDR		<= '0';
	ADC_SCLK		<= '0';

	GPIO2_D_00		<= 'Z';
	GPIO2_D_01		<= 'Z';
	GPIO2_D_02		<= 'Z';
	GPIO2_D_03		<= 'Z';
	GPIO2_D_04		<= 'Z';
	GPIO2_D_05		<= 'Z';
	GPIO2_D_06		<= 'Z';
	GPIO2_D_07		<= 'Z';
	GPIO2_D_08		<= 'Z';
	GPIO2_D_09		<= 'Z';
	GPIO2_D_10		<= 'Z';
	GPIO2_D_11		<= 'Z';
	GPIO2_D_12		<= 'Z';

end RTL;
