;
;	SD card file control program
;
	ORG	0000H
;

FIRMVER:	EQU	0001H

INITSP:		EQU	0FFFH
;
; buffer location
;
REG_SDBUF:	EQU	8000H
REG_OFFSET:	EQU	81C6H

BPB_SECBYTE	EQU	800BH
BPB_CLASTSEC:	EQU	800DH
BPB_FATST:	EQU	800EH
BPB_FATNUM	EQU	8010H
BPB_DIRENTRY	EQU	8011H
BPB_FATSEC:	EQU	8016H
BPB_FATVER:	EQU	8039H

;
; register mapping
;
REG_SDCMDST:	EQU	8200H
REG_SDCTRL:	EQU	8201H
REG_SDRDDONE:	EQU	8202H
REG_SDEJECT:	EQU	8204H
REG_SDCMDNO:	EQU	8205H
REG_SDADD:	EQU	8206H
REG_DBGTRG:	EQU	820FH

REG_CTRLRST:	EQU	8210H
REG_BUFSEL:	EQU	8211H
REG_SDRD:	EQU	8213H
REG_BUFUPPER:	EQU	8214H
REG_BUFEMPTY:	EQU	8215H
REG_CGFRAME:	EQU	8216H
REG_PCMFRAME:	EQU	8217H
REG_CGFILEEND:	EQU	8218H
REG_PCMFILEEND:	EQU	8219H
REG_COMMAND:	EQU	821AH
REG_CMDSTART:	EQU	821BH
REG_CMDEND:	EQU	821CH
REG_CGSEL:	EQU	821DH


FIFO_CMTLEN:	EQU	00H
FIFO_CMTPTR:	EQU	04H
FIFO_CL:	EQU	08H
FIFO_SEC:	EQU	0AH
FIFO_STCL:	EQU	0BH
FIFO_BEFCL:	EQU	0DH
FIFO_DIRCL:	EQU	0FH
FIFO_DIRPOS:	EQU	11H

FIFO_NUM:	EQU	13H


START:

	LD	SP,INITSP
	LD	A,0FFH
	LD	I,A
	EI
	XOR	A
	LD	(REG_DBGTRG),A

	CALL	DETSDEJECT
	CALL	SDCARD_OPEN

		;
CMDWRWAIT:
	LD	A,(REG_CMDSTART)
	OR	A
	JR	Z,CMDWRWAIT

	LD	A,(REG_COMMAND)
	LD	B,A
	DJNZ	CMD_LP2

		;
		; command = 0x01
		; f[^obt@P6ǂݏ\ɂ
		;
	LD	A,01
	LD	(REG_DBGTRG),A
	XOR	A
	LD	(REG_DBGTRG),A
	LD	A,0AH
	LD	(REG_BUFSEL),A
	JR	CMDFINISH

CMD_LP2:
	DJNZ	CMD_LP3

		;
		; command = 0x02 OFFSET
		; [gfBNgo
		;
	LD	A,09H
	LD	(REG_BUFSEL),A
	LD	A,(REG_SDBUF+0)
	CALL	DIRROOT
	JR	CMDFINISH

CMD_LP3:
	DJNZ	CMD_LP4

		;
		; command = 0x03 FILENAME
		; t@Ceo
		;
	LD	A,09H
	LD	(REG_BUFSEL),A
	LD	HL,REG_SDBUF
	LD	DE,F_CGFILE
	LD	B,0BH
	LDIR
	CALL	READFILE
	JR	CMDFINISH

CMD_LP4:
	DJNZ	CMD_LP5

		;
		; command = 0x04 CGFILENAME PCMFILENAME
		; [r[t@C̎w
		;
	LD	A,09H
	LD	(REG_BUFSEL),A
	LD	HL,REG_SDBUF
	LD	DE,F_CGFILE
	LD	B,12H
	LDIR
	JR	CMDFINISH

CMD_LP5:
	DJNZ	CMD_LP6

		;
		; command = 0x05 CGFRAME PCMFRAME
		; [r[̍Đ
		;
	LD	A,09H
	LD	(REG_BUFSEL),A
	LD	A,(REG_SDBUF+0)
	LD	(REG_CGFRAME),A
	LD	A,(REG_SDBUF+1)
	LD	(REG_PCMFRAME),A
	CALL	MOVIE
	JP	CMDWRWAIT

CMD_LP6:
	JR	CMDFINISH

CMDFINISH:
	LD	A,01H
	LD	(REG_CMDEND),A

CMDRDWAIT:
	LD	A,(REG_CMDSTART)
	OR	A
	JR	NZ,CMDRDWAIT

	XOR	A
	LD	(REG_CMDEND),A

	JP	CMDWRWAIT


		;
		; [r[Đ
		;
MOVIE:
	XOR	A
	LD	(SDMODE),A

	XOR	A
	LD	(REG_CGFILEEND),A
	LD	(REG_PCMFILEEND),A
	CALL	SDREGINIT
	CALL	SDADDINIT

	CALL	SETCGFILE
	JP	C,SDERR

	CALL	SETPCMFILE
	JP	C,SDERR

	LD	A,01H
	LD	(REG_CTRLRST),A
	XOR	A
	LD	(REG_CTRLRST),A

	LD	A,04H
	CALL	READCGFILE
	LD	A,05H
	CALL	READCGFILE
	LD	A,06H
	CALL	READCGFILE
	LD	A,07H
	CALL	READCGFILE

	LD	A,01H
	LD	(REG_CMDEND),A
CMDRDWAIT2:
	LD	A,(REG_CMDSTART)
	OR	A
	JR	NZ,CMDRDWAIT2
	XOR	A
	LD	(REG_CMDEND),A

MAINLOOP:
;	CALL	DETSDEJECT

	LD	A,(REG_BUFEMPTY)
	AND	01H
	JR	Z,ML1

	LD	A,04H
	CALL	READCGFILE

ML1:	LD	A,(REG_BUFEMPTY)
	AND	02H
	JR	Z,ML2

	LD	A,05H
	CALL	READCGFILE

ML2:	LD	A,(REG_BUFEMPTY)
	AND	04H
	JR	Z,ML3

	LD	A,06H
	CALL	READCGFILE

ML3:	LD	A,(REG_BUFEMPTY)
	AND	08H
	JR	Z,ML4

	LD	A,07H
	CALL	READCGFILE

ML4:	LD	A,(REG_CGFILEEND)
	OR	A
	JR	Z,MAINLOOP

	RET



; read CG file parameter
;
; RETURN:Cflag=1 FILE not found
SETCGFILE:
	LD	IX,F_CGFILE
	LD	IY,CGPARAM
	XOR	A
	LD	(SEARCHTYPE),A
	LD	HL,0000H
	LD	(DIRCL),HL
	CALL	FILESEARCH

	RET

; read PCM file parameter
;
; RETURN:Cflag=1 FILE not found
SETPCMFILE:
	LD	IX,F_PCMFILE
	LD	IY,PCMPARAM
	XOR	A
	LD	(SEARCHTYPE),A
	LD	HL,0000H
	LD	(DIRCL),HL
	CALL	FILESEARCH

	RET


; read CG/PCM file
;
; Areg : buffer type (4:CG#0 5:CG#1 6:PCM#0 7:PCM#1)
; RETURN : Cflag=1 file end
;
READCGFILE:
	LD	(REG_BUFSEL),A
	LD	IY,CGPARAM
	LD	HL,REG_CGFILEEND
	LD	C,10H		; 512bytes x 16
	CP	06H
	JR	C,CGFL2
	LD	IY,PCMPARAM
	LD	HL,REG_PCMFILEEND
	LD	C,02H		; 512bytes x 2
CGFL2:	LD	A,(HL)
	OR	A
	RET	NZ
	PUSH	HL

	LD	A,01H
	LD	(REG_SDCTRL),A
		;
	LD	B,00H
CGFL1:
	PUSH	BC
	LD	A,B
	LD	(REG_BUFUPPER),A

	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,L
	OR	H
	JP	Z,SDERR_DBG1
	LD	A,(IY+FIFO_SEC)
	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
		;
	CALL	READ1SEC_BUF
		;
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,(IY+FIFO_SEC)
	CALL	GET_NEXTSEC
	LD	(IY+FIFO_CL+0),L
	LD	(IY+FIFO_CL+1),H
	LD	(IY+FIFO_SEC),A

	LD	A,(IY+FIFO_CMTPTR+1)
	ADD	A,02H
	LD	(IY+FIFO_CMTPTR+1),A
	LD	A,(IY+FIFO_CMTPTR+2)
	ADC	A,00H
	LD	(IY+FIFO_CMTPTR+2),A
	LD	A,(IY+FIFO_CMTPTR+3)
	ADC	A,00H
	LD	(IY+FIFO_CMTPTR+3),A

	POP	BC
	INC	B
	LD	A,B
	CP	C
	JR	NZ,CGFL1

	POP	HL

	LD	A,(IY+FIFO_CMTLEN+3)
	CP	(IY+FIFO_CMTPTR+3)
	JR	C,CGFL_F
	JR	NZ,CGFL_NF
	LD	A,(IY+FIFO_CMTLEN+2)
	CP	(IY+FIFO_CMTPTR+2)
	JR	C,CGFL_F
	JR	NZ,CGFL_NF
	LD	A,(IY+FIFO_CMTLEN+1)
	CP	(IY+FIFO_CMTPTR+1)
	JR	C,CGFL_F
	JR	NZ,CGFL_NF
	LD	A,(IY+FIFO_CMTLEN+0)
	CP	(IY+FIFO_CMTPTR+0)
	JR	C,CGFL_F
	JR	NZ,CGFL_NF
CGFL_F:
	LD	(HL),01H
CGFL_NF:
	XOR	A
	LD	(REG_SDCTRL),A
	LD	A,08H
	LD	(REG_BUFSEL),A
	RET

; ROOT directory read
;
; Areg:file number
;
DIRROOT:
	RLCA
	RLCA
	RLCA
	RLCA
	LD	L,A
	LD	H,00H
	LD	(DIRPOS),HL
	LD	A,08H
	LD	(REG_BUFSEL),A
	LD	A,01H
	LD	(REG_SDCTRL),A
		;
	LD	HL,0000H
	LD	(DIRCL),HL	; root
	CALL	SDADDINIT
	CALL	READ_DIRFILE
		;
	XOR	A
	LD	(REG_SDCTRL),A

	RET


; file read in root directory
;
; (F_CGFILE):file name
;
READFILE:
	LD	IX,F_CGFILE
	LD	IY,CGPARAM
	XOR	A
	LD	(SEARCHTYPE),A
	LD	HL,0000H
	LD	(DIRCL),HL
	CALL	FILESEARCH

	LD	A,08H
	LD	(REG_BUFSEL),A
	LD	A,01H
	LD	(REG_SDCTRL),A
	
	LD	L,(IY+FIFO_CL+0)
	LD	H,(IY+FIFO_CL+1)
	LD	A,L
	OR	H
	JP	Z,SDERR_DBG1
	LD	A,(IY+FIFO_SEC)
	CALL	CALCSDADD
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
		;
	CALL	READ1SEC_BUF
		;
	XOR	A
	LD	(REG_SDCTRL),A
	RET


;
; set file parameter
; IX <= file name address
;
SETFILEPARA:
	PUSH	HL
	LD	HL,(DIRCL)
	LD	(IY+FIFO_DIRCL+0),L
	LD	(IY+FIFO_DIRCL+1),H
	LD	HL,(DIRPOS)
	LD	(IY+FIFO_DIRPOS+0),L
	LD	(IY+FIFO_DIRPOS+1),H
	POP	HL

SETFILEPARA2:
	LD	A,(HL)
	LD	(IY+FIFO_CL+0),A
	LD	(IY+FIFO_STCL+0),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CL+1),A
	LD	(IY+FIFO_STCL+1),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+0),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+1),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+2),A
	INC	HL
	LD	A,(HL)
	LD	(IY+FIFO_CMTLEN+3),A

	XOR	A
	LD	(IY+FIFO_CMTPTR+0),A
	LD	(IY+FIFO_CMTPTR+1),A
	LD	(IY+FIFO_CMTPTR+2),A
	LD	(IY+FIFO_CMTPTR+3),A

	RET




; file search in directory
; IX <= file name address
; IY <= use FIFO number
; (DIRCL) <= claster number of directory claster (0000H = root)
; (SEARCHTYPE) <= search file type (00H:file 10H:directory)
;
; RETURN
; (IY+FIFO_CMTLEN) <= file length
; (IY+FIFO_CL)     <= file claster number
; (IY+FIFO_SEC)    <= file sector number
; (IY+FIFO_STCL)   <= file start claster number
; (IY+FIFO_DIRCL)  <= file claster in directory
; (IY+FIFO_DIRPOS) <= file position in directory
; Cflag = 1           file not found
FILESEARCH:
	LD	A,01H
	LD	(REG_SDCTRL),A
	LD	HL,0000H
	LD	(DIRPOS),HL
	CALL	SDADDINIT
		;
FSL1:	CALL	READ_DIRFILE
		;
	LD	A,(HL)
	OR	A
	JR	Z,FSL3
	PUSH	IX
	POP	DE
	PUSH	HL
	LD	B,0BH
	CALL	CP_MHL_MDE
	POP	HL
	JR	NZ,FSL11
	LD	BC,000BH
	ADD	HL,BC
	LD	A,(HL)
	AND	1EH
	LD	B,A
	LD	A,(SEARCHTYPE)
	CP	B
	JR	Z,FSL2
		;
FSL11:	LD	HL,(DIRPOS)
	INC	HL
	LD	(DIRPOS),HL
	LD	A,H
	CP	02H
	JR	NC,FSL3
	JR	FSL1
		;
FSL2:	LD	BC,000FH
	ADD	HL,BC
	
	CALL	SETFILEPARA
		;
	XOR	A
	LD	(IY+FIFO_SEC),A
	LD	(REG_SDCTRL),A
	RET

FSL3:
	XOR	A
	LD	(IY+FIFO_SEC),A
	LD	(REG_SDCTRL),A
	SCF
	RET


;
; SD card initialized and read parameter
;
SDCARD_OPEN:
		;
		; wait
		;
	LD	B,08H
SDOP2:	LD	HL,0000H
SDOP1:	DEC	HL
	LD	A,H
	OR	L
	JR	NZ,SDOP1
	DJNZ	SDOP2

	LD	HL,REG_SDCTRL
	LD	(HL),01H	; SD card enable
;
; command 0 (S/W reset)
;
	LD	HL,0000H
	LD	(REG_SDADD),HL
	LD	(REG_SDADD+2),HL
	XOR	A
	CALL	SENDCMD2
;
; command 1 (idle detect)
;
SDW1:	LD	A,01H
	CALL	SENDCMD2
	BIT	1,(HL)
	JR	NZ,SDW1
;
; command 16 (length set)
;
	LD	A,10H
	CALL	SENDCMD
;
; read phisical sector #0
;
	LD	HL,0000H
	LD	(REG_SDADD),HL
	LD	(REG_SDADD+2),HL
	CALL	READ1SEC
	LD	HL,REG_OFFSET
	LD	DE,OFFSET
	CALL	LD4B_MDE_MHL
;
; read logical sector #0 (read BPB parameter)
;
	LD	HL,OFFSET
	CALL	LD4B_REG_SDADD_MHL
	CALL	READ1SEC
	CALL	CHKSPT
		;
		; claster size = BPB_CLASTSEC
		;
	LD	A,(BPB_CLASTSEC)
	LD	(CLASTSIZE),A
		;
		; FAT start = OFFSET + BPB_FATST
		;
	LD	HL,(OFFSET)
	LD	DE,(BPB_FATST)
	ADD	HL,DE
	LD	(FATST),HL
	LD	HL,(OFFSET+2)
	LD	DE,0000H
	ADC	HL,DE
	LD	(FATST+2),HL
;;		;
;;		; root directory start = FATST + BPB_FATNUM x BPB_FATSEC
;;		;
;;	LD	DE,ROOTST
;;	LD	HL,FATST
;;	CALL	LD4B_MDE_MHL
;;	LD	HL,(BPB_FATSEC)
;;	LD	(WORK),HL
;;	LD	HL,0000H
;;	LD	(WORK+2),HL
;;
;;	LD	A,(BPB_FATNUM)
;;	LD	B,08H
;;RDLP1:	RRCA
;;	PUSH	AF
;;	PUSH	BC
;;	JR	NC,RDLP2
;;	LD	HL,ROOTST
;;	LD	DE,WORK
;;	CALL	ADD4B_MHL_MDE
;;		;
;;RDLP2:	LD	HL,WORK
;;	CALL	SHT4B_MHL
;;		;
;;	POP	BC
;;	POP	AF
;;	DJNZ	RDLP1
		;
		; FAT use sector number = BPB_FATSEC
		;
	LD	HL,(BPB_FATSEC)
	LD	(FATSEC),HL
		;
		; root directory start = FATST + BPB_FATNUM(=02H) x FATSEC
		;
	LD	DE,ROOTST
	LD	HL,FATST
	CALL	LD4B_MDE_MHL
	LD	HL,(FATSEC)
	LD	(WORK),HL
	LD	HL,0000H
	LD	(WORK+2),HL
	LD	HL,WORK
	CALL	SHT4B_MHL
	LD	HL,ROOTST
	LD	DE,WORK
	CALL	ADD4B_MHL_MDE
		;
		; claster start = ROOTST + 32
		;
	LD	HL,ROOTST
	LD	DE,CLASTST
	CALL	LD4B_MDE_MHL
	LD	HL,CLASTST
	LD	A,20H
	CALL	ADD4B_MHL_A
		;
	XOR	A
	LD	(REG_SDCTRL),A
		;
	RET


; directory file list read
; (DIRCL)     <= claster number of directory claster (0000H = root)
; (DIRPOS)    <= file position in directory
;
; RETURN
; HL:file list pointer address
;
READ_DIRFILE:
	LD	HL,(DIRPOS)
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	B,H
	LD	HL,(DIRCL)
	LD	A,H
	OR	L
	JR	NZ,RDL1
		;
		; root directory
		;
	LD	HL,ROOTST
	PUSH	BC
	CALL	LD4B_WORK_MHL
	POP	BC
	LD	A,B
	LD	HL,WORK
	CALL	ADD4B_MHL_A
	JR	RDL2
		;
		;
RDL1:	XOR	A
	INC	B
		;
RDL3:	DEC	B
	JR	Z,RDL4
	PUSH	BC
	CALL	GET_NEXTSEC
	POP	BC
	JR	RDL3
		;
RDL4:	CALL	CALCSDADD
		;

RDL2:	LD	HL,WORK
	LD	DE,REG_SDADD
	LD	B,04H
	CALL	CP_MHL_MDE
	JR	Z,RDL5
		;
	LD	HL,WORK
	CALL	LD4B_REG_SDADD_MHL
	CALL	READ1SEC
		;
RDL5:	LD	A,(DIRPOS)
	AND	0FH
	LD	L,A
	LD	H,00H
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	ADD	HL,HL
	LD	DE,REG_SDBUF
	ADD	HL,DE
	RET


; claster and sector number -> SD address
;
; SD address <= CLASTST + CLASTSIZE x (claster - 2) + sector
; HL : claster number
; A  : sector number
;
; RETURN : (WORK) <- SD address
;
CALCSDADD:
	CALL	CLASTCHECK
	DEC	HL
	DEC	HL
	LD	(WORK2),HL
	LD	HL,0000H
	LD	(WORK2+2),HL
		;
	LD	HL,CLASTST
	CALL	LD4B_WORK_MHL
	LD	HL,WORK
	CALL	ADD4B_MHL_A
		;	
	LD	A,(CLASTSIZE)
	LD	B,08H
CSAL2:	RRCA
	PUSH	AF
	PUSH	BC
	JR	NC,CSAL1
	LD	HL,WORK
	LD	DE,WORK2
	CALL	ADD4B_MHL_MDE
		;
CSAL1:	LD	HL,WORK2
	CALL	SHT4B_MHL
		;
	POP	BC
	POP	AF
	DJNZ	CSAL2
		;
	RET



; get next sector
; HL : claster number
; A  : sector number
;
; RETURN
; HL <= next claster number
; A  <= next sector number
;
GET_NEXTSEC:
	CALL	CLASTCHECK
	LD	C,A
	INC	C
	LD	A,(CLASTSIZE)
	LD	B,A
	LD	A,C
	CP	B
	RET	C
		;
	CALL	GET_NEXTCL
	XOR	A
	RET


; get next claster number from FAT
; HL : claster number
;
; RETURN : HL <= next claster number
;
GET_NEXTCL:
	CALL	CLASTCHECK

	PUSH	HL
	CALL	SDADDINIT
	POP	HL
	XOR	A
	CALL	CALCFATADD	

	LD	E,(HL)
	INC	HL
	LD	D,(HL)
	EX	DE,HL
	RET


; claster number check
; HL : claster number
;
CLASTCHECK:
	PUSH	HL
	PUSH	DE
	LD	DE,0FFF7H
	OR	A
	SBC	HL,DE
	JP	NC,SDERR_DBG2
	POP	DE
	POP	HL
	RET


; FAT address calculate
; HL <= claster number
; A  <= 1:FAT#2 0:FAT#1
;
; RETURN
; HL <= FAT address
;
CALCFATADD:
	PUSH	HL
	PUSH	AF
	PUSH	HL

	LD	DE,WORK3
	LD	HL,REG_SDADD
	CALL	LD4B_MDE_MHL

		;
		; SDADD <= FATST + claster number / 16 (+ FATSEC)
		;
	LD	HL,FATST
	CALL	LD4B_REG_SDADD_MHL
	POP	HL
	LD	A,H
	LD	HL,REG_SDADD
	CALL	ADD4B_MHL_A
	POP	AF
	OR	A
	JR	Z,CFAL1
		;
	LD	HL,(FATSEC)
	LD	(WORK+0),HL
	LD	HL,0000H
	LD	(WORK+2),HL
	LD	DE,WORK
	LD	HL,REG_SDADD
	CALL	ADD4B_MHL_MDE
CFAL1:
		;
	LD	HL,WORK3
	LD	DE,REG_SDADD
	LD	B,04H
	CALL	CP_MHL_MDE
		;
	CALL	NZ,READ1SEC
		;
	POP	HL
	LD	H,00H
	ADD	HL,HL
	LD	DE,REG_SDBUF
	ADD	HL,DE

	RET

;
; (HL)x4b <- (HL)x4b + (DE)x4b
;
ADD4B_MHL_MDE:
	LD	A,(DE)
	ADD	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	INC	DE
	INC	HL
	LD	A,(DE)
	ADC	A,(HL)
	LD	(HL),A
	RET


;
; (HL)x4b <- (HL)x4b + A
;
ADD4B_MHL_A:
	ADD	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	INC	HL
	LD	A,00H
	ADC	A,(HL)
	LD	(HL),A
	RET


;
; (HL)x4b <- (HL)x4b x 2
;
SHT4B_MHL:
	OR	A
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	INC	HL
	LD	A,(HL)
	RLA
	LD	(HL),A
	RET


;
; CP (HL)-(DE) x B byte
;
; RETURN
; (HL) > (DE) : Cflag reset / Zflag reset
; (HL) = (DE) : Cflag reset / Zflag set
; (HL) < (DE) : Cflag set   / Zflag reset
;
CP_MHL_MDE:
	LD	A,B
CPL1:	INC	DE
	INC	HL
	DJNZ	CPL1
	LD	B,A

CPL2:	DEC	DE
	DEC	HL
	LD	A,(DE)
	CP	(HL)
	CCF
	RET	NZ
	DJNZ	CPL2
	XOR	A
	RET

;
; (DE)x4b <- (HL)x4b
;
LD4B_MDE_MHL:
	LD	BC,0004H
	LDIR
	RET

;
; (REG_SDADD)x4b <- (HL)x4b
;
LD4B_REG_SDADD_MHL:
	LD	DE,REG_SDADD
	LD	BC,0004H
	LDIR
	RET

;
; (WORK)x4b <- (HL)x4b
;
LD4B_WORK_MHL:
	LD	DE,WORK
	LD	BC,0004H
	LDIR
	RET


;
; read 1 sector
;
READ1SEC:
	LD	A,08H		; SD -> FIFO
	LD	(REG_BUFSEL),A
	LD	HL,REG_SDRD
	LD	(HL),01H
	DEC	(HL)
	LD	A,11H
	CALL	SENDCMD
RSL1:	LD	A,(REG_SDRD)
	AND	10H
	JR	Z,RSL1
	LD	A,09H		; FIFO -> CPU
	LD	(REG_BUFSEL),A
	RET

;
; read 1 sector to write buffer
;
READ1SEC_BUF:
	LD	HL,REG_SDRD
	LD	(HL),01H
	DEC	(HL)
	LD	A,11H
	CALL	SENDCMD
RSLB1:	LD	A,(REG_SDRD)
	AND	10H
	JR	Z,RSLB1
	RET


SENDCMD:
;
; Areg <= command_No
;
	LD	(REG_SDCMDNO),A
	LD	HL,REG_SDCMDST
	LD	(HL),01H
	DEC	(HL)
SCL1:	BIT	0,(HL)
	JR	NZ,SCL1
	LD	A,06H
	AND	(HL)
	JR	NZ,SDERR
	RET


SENDCMD2:
;
; Areg <= command_No
;
	LD	(REG_SDCMDNO),A
	LD	HL,REG_SDCMDST
	LD	(HL),01H
	DEC	(HL)
SCL2:	BIT	0,(HL)
	JR	NZ,SCL2
	BIT	2,(HL)
	JR	NZ,SDERR
	RET


CHKSPT:
;
; SD card support check
;
; FAT16
; # of FAT = 02H
; # of sector byte = 0200H
; # of root directory entry = 0200H

	LD	HL,(BPB_FATVER)
	LD	DE,3631H
	OR	A
	SBC	HL,DE
	JR	NZ,SDERR
		;
	LD	A,(BPB_FATNUM)
	CP	02H
	JR	NZ,SDERR
		;
	LD	HL,(BPB_SECBYTE)
	LD	DE,0200H
	OR	A
	SBC	HL,DE
	JR	NZ,SDERR
		;
	LD	HL,(BPB_DIRENTRY)
	OR	A
	SBC	HL,DE
	JR	NZ,SDERR
	RET

SDERR_DBG1:
	LD	A,01H
	LD	(REG_DBGTRG),A
	JR	SDERR

SDERR_DBG2:
	LD	A,02H
	LD	(REG_DBGTRG),A
	JR	SDERR

SDERR:
;
; SD card error
;

SDERR2:
	LD	A,02H
	LD	(REG_SDCTRL),A
ERRLPP:	JR	ERRLPP


;	LD	A,02H
;	LD	(REG_SDCTRL),A
;	LD	A,(SDMODE)
;	OR	A
;ERRLP:	JR	Z,ERRLP
;
;ERRLP2:	LD	A,(REG_SDEJECT)
;	OR	A
;	JR	Z,ERRLP2
;
;SDERR2:
;	XOR	A
;	LD	(REG_SDCTRL),A
;	LD	A,01H
;	LD	(REG_CTRLRST),A
;ERRLP3:	LD	A,(REG_SDEJECT)
;	OR	A
;	JR	NZ,ERRLP3
;	XOR	A
;	LD	(REG_CTRLRST),A
;	JP	START


;
; SD registers and circuits initialize
;
SDREGINIT:
	CALL	SDREGINIT_0
	CALL	SDREGINIT_1
		;
	LD	HL,REG_SDRD
	LD	(HL),01H
	LD	(HL),00H
		;
	RET


;
; SD registers and circuits initialize (CG)
;
SDREGINIT_0:
	PUSH	HL
	LD	HL,CGPARAM
	XOR	A
	LD	B,FIFO_NUM
SRL1_0:	LD	(HL),A
	INC	HL
	DJNZ	SRL1_0
		;
	LD	IY,CGPARAM
		;
	POP	HL
	RET

;
; SD registers and circuits initialize (PCM)
;
SDREGINIT_1:
	PUSH	HL
	LD	HL,PCMPARAM
	XOR	A
	LD	B,FIFO_NUM
SRL1_1:	LD	(HL),A
	INC	HL
	DJNZ	SRL1_1
		;
	LD	IY,PCMPARAM
		;
	POP	HL
	RET




;
; SD address initialize
;
SDADDINIT:
	LD	HL,0FFFFH
	LD	(REG_SDADD),HL
	LD	(REG_SDADD+2),HL
	RET


;
; detect SD card insert or eject
;
DETSDEJECT:
	LD	A,(REG_SDEJECT)
	OR	A
	RET	Z
	JP	SDERR2



;
; offset address
;
OFFSET:		DB	00H,00H,00H,00H

;
; FAT start address
;
FATST:		DB	00H,00H,00H,00H

;
; FAT use sector number
;
FATSEC:		DB	00H,00H

;
; root directory start address
;
ROOTST:		DB	00H,00H,00H,00H

;
; claster start address (claster number is #2)
;
CLASTST:	DB	00H,00H,00H,00H

;
; claster size (x512 byte)
;
CLASTSIZE:	DB	00H

;
; directory start address (temporary)
;
DIRCL:		DB	00H,00H

;
; directory file pointer (temporary)
;
DIRPOS:		DB	00H,00H

;
; 4 byte calc work
;
WORK:		DB	00H,00H,00H,00H
WORK2:		DB	00H,00H,00H,00H
WORK3:		DB	00H,00H,00H,00H
WORK4:		DB	00H,00H,00H,00H

;
; return mode of SD error
;
SDMODE:		DB	00H

;
; read flag
;
; 00H : no selected file
; 01H : selected and no read
; 02H : selected and reading
;
READFLAG:	DB	00H

;
; search file type
; 00H:file
; 10H:directory
;
SEARCHTYPE:	DB	00H

;
; CG file parameter
;
CGPARAM:	DB	00H,00H,00H,00H	; file length
		DB	00H,00H,00H,00H	; file pointer
		DB	00H,00H		; file claster
		DB	00H		; file sector
		DB	00H,00H		; start claster
		DB	00H,00H		; before claster
		DB	00H,00H		; parent directory claster
		DB	00H,00H		; file position in parent directory

;
; PCM file parameter
;
PCMPARAM:	DB	00H,00H,00H,00H	; file length
		DB	00H,00H,00H,00H	; file pointer
		DB	00H,00H		; file claster
		DB	00H		; file sector
		DB	00H,00H		; start claster
		DB	00H,00H		; before claster
		DB	00H,00H		; parent directory claster
		DB	00H,00H		; file position in parent directory


F_CGFILE	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H
F_PCMFILE	DB	00H,00H,00H,00H,00H,00H,00H,00H,00H,00H,00H

	END

